
from math import *
import Image
import psyco
psyco.full()

def exposant_lyapunov(a,b,init,itera):
#        "Calcul de l'exposant. a -> x, b -> y, init -> itrations d'ammorage, itera -> itrations de calcul"
    global log2
    sequence=[a,b,b,a]
    max_seque=3
    x=0.5
    total=0
    i=0
    seque_init=-1
    while i < init:
        i = i + 1
        seque_init=seque_init + 1
        if seque_init > max_seque:
            seque_init = 0
            x=sequence[seque_init]*x*(1.0-x)
        i=0
        seque_init = -1
        while i < itera:
            i = i + 1
            seque_init=seque_init + 1
            if seque_init > max_seque:
                seque_init = 0
            x=sequence[seque_init]*x*(1.0-x)
            total=total+(log(abs(sequence[seque_init]-2.0*sequence[seque_init]*x))/log2)
    exposant=total/itera
    return exposant

def couleur(exposant):
#      "Calcul de la couleur d'un pixel selon la palette utilise et son exposant"
    global maxResult
    global minResult
    global iterations_used
    global longueur_palette_plus
    global longueur_palette_minus
    global colpalplus
    global colpalminus
    global final
    if exposant > 0:
        echelle=(maxResult/longueur_palette_plus)
        cindex = abs(int(exposant/echelle))
        if cindex > longueur_palette_plus - 1:
            cindex = longueur_palette_plus - 1
        if cindex < 0:
            cindex = 0
        final = colpalplus[cindex]
    else:
        echelle=(minResult/longueur_palette_minus)
        cindex = abs(int(exposant/echelle))
        if cindex > longueur_palette_minus - 1:
            cindex = longueur_palette_minus - 1
        if cindex < 0:
            cindex = 0
        final = colpalminus[cindex]
    return final

    # Parametres des palettes de couleur
colpalplus=[]
colpalminus=[]

    ## Reglages de base
maxResult=(sqrt(5)-1.0)/2.0
minResult=(sqrt(5)+1.0)/2.0
longueur_palette_plus=256
longueur_palette_minus=511

    ## Palette CHAOS
    # bleu -> noir
    #i=0
    #while i < 256:
    #    colpalplus.append((0, 0, 255 - i))
    #    i = i + 1

    # blanc -> noir
    #i=0
    #while i < 256:
    #    colpalplus.append((255 - i, 255 - i, 255 - i))
    #    i = i + 1

    # noir -> noir
i=0
while i < 256:
    colpalplus.append((0, 0, 0))
    i = i + 1
maxResult=1.9333897126112

    ## Palette STABLE
    # noir -> jaune -> blanc
    #i=0
    #while i < 256:
    #    colpalminus.append((i, i, 0))
    #    i = i + 1
    #while i < 511:
    #    colpalminus.append((255, 255, i - 255))  #
    #    i = i + 1

    # blanc -> gris -> noir
    #i=0
    #while i < 256:
    #    colpalminus.append((255-i, 255-i, 255-i))
    #    i = i + 1
    #while i < 511:
    #    colpalminus.append((i - 255, i - 255, i - 255))
    #    i = i + 1

    # noir -> jaune
i=0
while i < 256:
    colpalminus.append((255-i, 255-i, 0))
    i = i + 1
longueur_palette_minus=256
minResult=-10.462186805818

    # Parametres de la fractale
    ## Tailles image
largeur=400
hauteur=400
    ## Itrations d'ammorage
iterations_unused=200
   ## Itrations de calcul
iterations_used=400
    ## Coordonnes du point bas gauche
    ## MEMO : x = largeur, y = hauteur
x=2.52
y=2.87
    ## Pas de coordonnes pour chaque pixel
steps=0.002825

    ## NOTE IMPORTANTE
    ## Ne jamais atteindre 4 pour une coordonne ((steps*taille)+x ou y)
    ## sous peine de math overflow

image_finale=[]

im = Image.new("RGB",(largeur,hauteur))

log2=log(2)

    # Construction
i=hauteur
j=1
while i > 0:
    while j <= largeur:
        image_finale.append(couleur(exposant_lyapunov(i*steps+y,j*steps+x,iterations_unused,iterations_used)))
        j = j+1
    j=1
    print( i,"(",hauteur," )")  ###
    i = i - 1

    # Enregistrement
im.putdata(image_finale)
im.save("lyapunov.jpg" )

print "Termin"
